/*
       Licensed to the Apache Software Foundation (ASF) under one
       or more contributor license agreements.  See the NOTICE file
       distributed with this work for additional information
       regarding copyright ownership.  The ASF licenses this file
       to you under the Apache License, Version 2.0 (the
       "License"); you may not use this file except in compliance
       with the License.  You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing,
       software distributed under the License is distributed on an
       "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
       KIND, either express or implied.  See the License for the
       specific language governing permissions and limitations
       under the License
*/
/*
 * IteratorsStack.java
 *
 * Created on 24 aprile 2003, 17.47
 * @author  Valter Crescenzi
 */

package roadrunner.ast;

import java.util.*;

public class IteratorsStack {
    
    private Stack stack;
    
    /** Creates a new instance of IteratorsStack */
    public IteratorsStack() {
        this.stack = new Stack();
    }
    
    public void register(ListIterator lit) {
        this.stack.push(lit);
    }
    
    public void unregister(ListIterator lit) {
        Object popped = this.stack.pop();
        if (popped!=lit)
            throw new RuntimeException("Popped element is not the expected one!");
    }
    
    public int[] makeIndices() {
        int indices[] = new int[this.stack.size()], i = 0;
        Iterator it = this.stack.iterator();
        while (it.hasNext()) {
            indices[i++] = ((ListIterator)it.next()).previousIndex();
        }
        return indices;
    }
    
}
