/*
       Licensed to the Apache Software Foundation (ASF) under one
       or more contributor license agreements.  See the NOTICE file
       distributed with this work for additional information
       regarding copyright ownership.  The ASF licenses this file
       to you under the Apache License, Version 2.0 (the
       "License"); you may not use this file except in compliance
       with the License.  You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing,
       software distributed under the License is distributed on an
       "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
       KIND, either express or implied.  See the License for the
       specific language governing permissions and limitations
       under the License
*/
/**
 * ImageToken.java
 *
 * Created on February 29, 2004, 20:40 PM
 * @author  Valter Crescenzi
 */

package roadrunner.parser.token;


import java.io.File;
import java.util.Map;

import roadrunner.parser.Token;

class ImageToken extends TagToken implements Token {
        
    private String src;
    
    /** Creates a new instance of TagToken */
    ImageToken(String sourceUrl, Tag tag, int code, int depth) {
        super(tag, code, depth);
        this.src = sourceUrl;
    }
    
    public String getText() {
        throw new RuntimeException("This object is supposed to be an Image Token!");
    }
    
    public boolean isIMG()    { return true;  }
    public String getIMGsrc() { return src;  }
    public boolean isLink()   { return false; }
    public String getLinkTarget() {
        throw new RuntimeException("This object is supposed to be an Image Token!");
    }
    
    public String getVariantValue() {
        // HACK: mozilla's "save with contents" produce
        //       different URLs for the same image
        if (this.getIMGsrc()==null) return "";
        return new File(this.getIMGsrc()).getName();
    }
    
}
