/*
       Licensed to the Apache Software Foundation (ASF) under one
       or more contributor license agreements.  See the NOTICE file
       distributed with this work for additional information
       regarding copyright ownership.  The ASF licenses this file
       to you under the Apache License, Version 2.0 (the
       "License"); you may not use this file except in compliance
       with the License.  You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing,
       software distributed under the License is distributed on an
       "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
       KIND, either express or implied.  See the License for the
       specific language governing permissions and limitations
       under the License
*/
/*
 * NullToken.java
 *
 * Created on December 25, 2003, 12:16 PM
 * @author  Valter Crescenzi
 */

package roadrunner.parser.token;

import java.util.Map;

import roadrunner.ast.ASTToken;
import roadrunner.parser.Token;

class NullToken extends ASTToken implements Token {
    
    private boolean is_pcdata,is_img,is_link;
    
    /** Creates a new instance of NullToken */
    NullToken(Token prototype) {
        super(prototype.depth(),prototype.code());
        this.is_pcdata = prototype.isPCDATA();
        this.is_img = prototype.isIMG();
        this.is_link = prototype.isLink();
    }
    NullToken(int depth) {
        super(depth,0);
        this.is_pcdata = true;
        this.is_img = false;
        this.is_link = false;
    }
    
    public Map getAttributes() {  return null;   }
    public String getElement() {  return null;   }
    public String getText()    {  return null;   }
    public String getVariantValue() { return null; }
    public boolean isPCDATA() { return is_pcdata; }
    public boolean isIMG()    { return is_img; }
    public boolean isLink()   { return is_link;}
}
