/*
       Licensed to the Apache Software Foundation (ASF) under one
       or more contributor license agreements.  See the NOTICE file
       distributed with this work for additional information
       regarding copyright ownership.  The ASF licenses this file
       to you under the Apache License, Version 2.0 (the
       "License"); you may not use this file except in compliance
       with the License.  You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing,
       software distributed under the License is distributed on an
       "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
       KIND, either express or implied.  See the License for the
       specific language governing permissions and limitations
       under the License
*/
/*
 * DOMLoaderTest.java
 *  JUnit based test
 *
 * Created on 3 marzo 2003, 15.53
  * @author Valter Crescenzi
 */

package roadrunner.config;

import junit.framework.*;

import java.io.*;
import java.net.URL;
import java.util.logging.*;
import javax.xml.parsers.*;

import org.w3c.dom.*;
import org.xml.sax.*;

import roadrunner.parser.*;
import roadrunner.Sample;
import roadrunner.Wrapper;

public class DOMLoaderTest extends TestCase {
  
  private static String  wrappersDir = "/home/crescenz/RoadRunner/current/test/fix/wrappers/";
  private static String  samplesDir  = "/home/crescenz/RoadRunner/current/test/fix/samples/";
  private static String  sfn2        = samplesDir  +"2ByName.xhtml";
  private static String  wfn         = wrappersDir + "rufusWrapper1.xml";
  private static Wrapper rufus;
  private static Sample  byname2;
  
  
  public DOMLoaderTest(java.lang.String testName) {
    super(testName);
  }
  
  public static void main(java.lang.String[] args) throws Exception {
    junit.textui.TestRunner.run(suite());
  }
  
  public static Test suite() {
    TestSuite suite = new TestSuite(DOMLoaderTest.class);
    
    return suite;
  }
    
  public void testParseHTML() throws Exception {
    System.out.println("testParseHTML");
    rufus = Wrapper.load(new File(wfn));
    byname2 = new Sample(new URL("file://"+sfn2), rufus.getPrefs());
    Token wt = (Token)rufus.getExpression().getRoot().jjtGetChild(0);//should be <html>
    Token st = (Token)byname2.getTokenlist().getTokens().get(0);
    assertEquals(wt.getElement(),st.getElement());
    assertEquals(wt.getAttributes().keySet(),st.getAttributes().keySet());    
    assertEquals(wt.code(),st.code());
  }

  
}
